#!/usr/bin/env python3
import argparse
from nullptr.commander import Commander
import os
from nullptr.store_analyzer import StoreAnalyzer
from nullptr.models.base import Base
def main(args):
  if not os.path.isdir(args.data_dir):
    os.makedirs(args.data_dir )
  if args.analyze:
    a = StoreAnalyzer(verbose=True)
    a.run(args.analyze)
  else:
    c = Commander(args.data_dir)
    c.run()
  
if __name__ == '__main__':
  parser = argparse.ArgumentParser()
  parser.add_argument('-d', '--data-dir', default='data')
  parser.add_argument('-a', '--analyze', type=argparse.FileType('rb'))
  args = parser.parse_args()
  main(args)
