from .base import Base, Reference
from nullptr.models.system import System
from nullptr.util import *
from time import time
from math import sqrt

class Waypoint(Base):
  def define(self):
    self.x:int = 0
    self.y:int = 0
    self.type:str = 'unknown'
    self.traits:list = []
    self.faction:str = ''
    self.is_under_construction:bool = False
    self.uncharted = True

    
  def update(self, d):
    self.seta('x', d)
    self.seta('y', d)
    self.seta('type', d)
    self.seta('faction', d, 'faction.symbol')
    self.seta('is_under_construction', d, 'isUnderConstruction')
    self.setlst('traits', d, 'traits', 'symbol')
    self.uncharted = 'UNCHARTED' in self.traits
    
  def created(self):
    self.get_system()
  
  def distance(self, other):
    return int(sqrt((self.x - other.x) ** 2 + (self.y - other.y) ** 2))
    
  @classmethod
  def ext(self):
    return 'way'
    
  def itraits(self):
    traits = []
    if self.type == 'JUMP_GATE':
      traits.append('JUMP')
    if self.type == 'GAS_GIANT':
      traits.append('GAS')
    if 'SHIPYARD' in self.traits:
      traits.append('SHIPYARD')
    if 'MARKETPLACE' in self.traits:
      traits.append('MARKET')
    
    
    if self.type == 'ASTEROID':
      if 'COMMON_METAL_DEPOSITS' in self.traits:
        traits.append('METAL')
      if 'PRECIOUS_METAL_DEPOSITS' in self.traits:
        traits.append('GOLD')
      if 'MINERAL_DEPOSITS' in self.traits:
        traits.append('MINS')
      if 'STRIPPED' in self.traits:
        traits.append('STRIPPED')
    return traits
  
  def f(self, detail=1):
    r = self.symbol
    if detail > 3:
      r += f'\n{self.x} {self.y}'
    return r